IMPLEMENTATION MODULE BT;
(*  1991-2016 Ari.Tao * 09.04.91 ~ 08.02.97 ++ 30.04.16                  .
                                                                           .
*)(*$S-,$T-,$Q+*)

FROM  BIOX IMPORT KBShiftS, ConCo,ConSo, ConIs, NecCi, CursBRate;
FROM  Aux  IMPORT WD,LW, IG,CD,LI,LC,
                  DivI, REM,REX, Sign, Equal, TD, TimeSt,DateSt;
FROM ASCII IMPORT BEL, BS,LF,CR,ESC, HT;

(***** VT52: *****)

TYPE S14 = ARRAY [0..14] OF CHAR;

PROCEDURE Esc  (VAR s: ARRAY OF CHAR); BEGIN wS (ESC); wS (s) END Esc;

PROCEDURE Lf;   BEGIN wS (LF) END Lf;
PROCEDURE Cr;   BEGIN wS (CR) END Cr;
PROCEDURE Cr1;  BEGIN Cr; Fw  END Cr1;
PROCEDURE Ln;   BEGIN Cr; IF ~mFlag THEN Lf END END Ln;
PROCEDURE Ln1;  BEGIN Ln; Fw  END Ln1;
PROCEDURE Bell; BEGIN wS(BEL) END Bell;
PROCEDURE Ht;   BEGIN wS (HT) END Ht;
PROCEDURE Sp;   BEGIN wS(" ") END Sp;
PROCEDURE GoXY (h, v: CARDINAL); VAR s: S14;
 BEGIN s:="@Y@@"; s[0]:=ESC;s[2]:=CHR(v+32);s[3]:=CHR(h+32); wS(s) END GoXY;
PROCEDURE Up;   BEGIN Esc ("A") END Up;
PROCEDURE Dn;   BEGIN Esc ("B") END Dn;
PROCEDURE Fw;   BEGIN Esc ("C") END Fw;
PROCEDURE Bc;   BEGIN Esc ("D") END Bc;
PROCEDURE Home; BEGIN Esc ("H") END Home;
PROCEDURE Hole; BEGIN GoXY ( 0, 223 (*max!*)) END Hole;
PROCEDURE Goal; BEGIN GoXY (223,223)(*max!*)  END Goal;
PROCEDURE Dark; BEGIN bCol (1); Clr; bCol (0) END Dark;
PROCEDURE Clr;  BEGIN Esc ("E") END Clr;
PROCEDURE ClrL; BEGIN Esc ("l") END ClrL; (* Zeile    lschen.*)
PROCEDURE ClrB; BEGIN Esc ("d") END ClrB; (* Oberhalb lschen.*)
PROCEDURE ClrE; BEGIN Esc ("J") END ClrE; (* Untrhalb lschen.*)
PROCEDURE Clre; BEGIN Esc ("K") END Clre; (* Hinten   lschen.*)
PROCEDURE Clrb; BEGIN Esc ("o") END Clrb; (* Vorne    lschen.*)
PROCEDURE RubL; BEGIN Esc ("M") END RubL; (* Zeile  entfernen.*)
PROCEDURE NewL; BEGIN Esc ("L") END NewL; (* Zeile hinzufgen.*)
PROCEDURE UpIL; BEGIN Esc ("I") END UpIL; (* quiv. Up v NewL.*)
PROCEDURE CurB; BEGIN Esc ("e") END CurB;
PROCEDURE Cur0; BEGIN Esc ("f") END Cur0;
PROCEDURE Save; BEGIN Esc ("j") END Save;
PROCEDURE Pose; BEGIN Esc ("k") END Pose;
PROCEDURE Wrap; BEGIN Esc ("v") END Wrap;
PROCEDURE Trap; BEGIN Esc ("w") END Trap;
PROCEDURE Inv1; BEGIN Esc ("p") END Inv1;
PROCEDURE Inv0; BEGIN Esc ("q") END Inv0;
PROCEDURE xCol (x: CHAR; c: CARDINAL); VAR s: S14;
 BEGIN s[0]:=ESC;s[1]:=x;s[2]:=CHAR(c+48);s[3]:=0c; wS (s) END xCol;
PROCEDURE fCol (c: CARDINAL); BEGIN xCol ('b', c) END fCol;
PROCEDURE bCol (c: CARDINAL); BEGIN xCol ('c', c) END bCol;
PROCEDURE GoX  (h: CARDINAL); (* Y>0! *)
 BEGIN IF mFlag THEN Up END; Cr; xInc (h DIV 8, Ht); hInc (h MOD 8) END GoX;
PROCEDURE xInc (n: INTEGER; p: PROC);
 BEGIN WHILE (0<n) DO DEC (n); p END END xInc;
PROCEDURE hInc (n: INTEGER); BEGIN xInc (n, Fw); xInc (-n, Bc) END hInc;
PROCEDURE vInc (n: INTEGER); BEGIN xInc (n, Dn); xInc (-n, Up) END vInc;
PROCEDURE Norm; VAR s: S14;  (* Home; Cur0; Inv0; bCol(0); fCol(1); Trap: *)
 BEGIN s:=" H f q c0 b1 w"; s[0]:=ESC;s[2]:=ESC;
       s[4]:=ESC;s[6]:=ESC;s[9]:=ESC;s[12]:=ESC;  ConSo (s) END Norm;

(***** Interaction: *****)

PROCEDURE Flush; VAR t: CHAR; BEGIN WHILE ConIs () DO rC (t) END END Flush;

PROCEDURE Pause;                                         (* Vgl. Ev.Pause *)
 BEGIN Flush; REPEAT UNTIL (KBShiftS() # {}) OR ConIs();
              REPEAT UNTIL (KBShiftS() = {});
       Flush; END Pause;

PROCEDURE KnotC;                            (* Fw,' ',Bc,CurB,Pause,Cur0: *)
 BEGIN Esc ("C "); Esc ("D"); Esc ("e"); Pause; Esc ("f") END KnotC;

PROCEDURE CurBR (new: INTEGER): (*oldRate:*) INTEGER;
 BEGIN RETURN CursBRate (new) END CurBR;

PROCEDURE Break (Choice: CS): CHAR;  VAR t: CHAR;
 BEGIN IF ConIs () THEN rC (t) ELSE t := 0c END;
       IF ~ ((t IN Choice) OR Equal (Choice, "", 0)) THEN t := 0c END;
       RETURN t; END Break;

PROCEDURE Query (Choice: CS): CHAR;  VAR t: CHAR;
 BEGIN Flush; REPEAT t := Break (Choice) UNTIL (t # 0c);
       Flush; RETURN t; END Query;

(***** Handling Numbers: *****)

VAR HEX: ARRAY [0..16] OF CHAR;
(*
PROCEDURE preD (i: LI; l: IG);
 BEGIN Fill (l-1);
   IF    (i < 0) THEN wC ('-');
   ELSIF (PLUS # FILL) THEN wC (PLUS);
   ELSIF (l > 0) THEN wC (FILL) END; END preD;
*)
PROCEDURE preD (i: LI; l: IG);
 BEGIN IF (i < 0) THEN Fill (l-1); wC ('-') ELSE Fill (l) END END preD;
PROCEDURE fF (l: IG); BEGIN WHILE (0 < l) DO wC (FILL); DEC (l) END END fF;

PROCEDURE  wDecL (I: LW;     L: IG);                   (* Vgl. Aux.LItoSt.*)
 PROCEDURE wdecl (i: LI; VAR l: IG);  VAR j: LI; r: IG;
  BEGIN DEC (l, Sign (l)); j := DivI (i, 10); REM; r := IG(REX);
    IF (i > 9) OR (i < -9) THEN wdecl (j, l) ELSE PreD (i, l) END;
    wC (CHR (30H+ ABS(r))); END wdecl;
 BEGIN wdecl (LI (I), L); Fill (-L); wC (0c) END wDecL;

PROCEDURE  wHexL (C: LW;     L: IG);    (* Vgl. ConvN.NumToSt & Aux.L2Hex.*)
 PROCEDURE whexl (c: LC; VAR l: IG);
  BEGIN DEC (l, Sign (l));
        IF ~((c >15) OR HEX0 & (c >9)) THEN Fill (l); (* Fhr. Dez-Ziffer?*)
        ELSE whexl (c DIV 16, l) END;
    wC (HEX [SHORT (c MOD 16)]); END whexl;
 BEGIN IF (HEXH # 0c) THEN DEC (L, Sign (L)) END;
       whexl (LC (C), L);
       IF (HEXH # 0c) THEN wC (HEXH) END;              (* Kenn-Buchstabe? *)
       Fill (-L); wC (0c); END wHexL;

PROCEDURE wDecW (i: WD; l: IG); BEGIN wDecL (LONG (IG(i)), l) END wDecW;
PROCEDURE wHexW (c: WD; l: IG); BEGIN wHexL (LONG (CD(c)), l) END wHexW;

PROCEDURE wTime (z: CARDINAL);  VAR T: TD;
 BEGIN T.n := TimeSt (z); T.z := 0c; wS (T.s) END wTime;
PROCEDURE wDate (z: CARDINAL);  VAR D: TD;
 BEGIN D.n := DateSt (z); D.z := 0c; wS (D.s) END wDate;

BEGIN wS := ConSo; wC := ConCo; mFlag := FALSE;
      HEX := "0123456789ABCDEF";
      ANY := CS {}; FILL := ' '; PLUS := FILL; HEXH := 'H'; HEX0 := FALSE;
      rC := NecCi; PreD := preD; Fill := fF;
  END BT .
