MODULE TurtlTxt;
(*$S-,$T-,$Q+                          .
               1991-2016 ari.tao * 09.04.91 ~ 01.11.92 + 03.06.95, 18.11.16
*)
FROM  Math0 IMPORT entier, sin, cos, real, pi;
FROM  ASCII IMPORT CR, SUB;
FROM   IO   IMPORT rd, wr,ws, Out,Inn, pDone;
FROM   BT   IMPORT wC, GoXY, Fw,Bc, Up,Dn, Lf,Cr, Ln,Ln1,Sp, Bell, Trap,
                   Dark, Clrb,ClrB,Clre,ClrE, ClrL,Clr, Home,Hole,Goal,
                   bCol,fCol, Inv0,Inv1, CurB,Cur0, NewL,RubL, Norm;
IMPORT BT, InOut;

CONST  MAXX = 79; MAXY = 24; EOT = SUB; Z0 = ORD ('0');
(*
PROCEDURE ReV (p: PROC); BEGIN Inv1; p; Inv0 END ReV;
*)

MODULE Turtle;
FROM   BT  IMPORT wC, GoXY, Fw,Bc, Up,Dn;
EXPORT Pt, Pen, Set, Pup, GoTo, ReP, Rep, Box, Frame;

VAR    pen, p:    CHAR;
       set:       BOOLEAN;
       x,y,x0,y0: INTEGER;
       X0,Y0:     CARDINAL;

PROCEDURE Pt;  BEGIN wC (pen)  END Pt;                (* Pnktchen setzen.*)
PROCEDURE Pen (z: CHAR); BEGIN pen := z END Pen;      (* Akt. Zeichen def.*)
PROCEDURE Set; BEGIN set := TRUE  END Set;            (* Stift aufsetzen. *)
PROCEDURE Pup; BEGIN set := FALSE END Pup;            (* Stift hochheben. *)
PROCEDURE GoTo (X,Y: CARDINAL);                       (* In gerader Linie,*)
 BEGIN x0 := x; y0 := y; x := X; y := Y;              (*   mit Aktualisrg.*)
    IF set THEN line ELSE GoXY (X,Y) END; END GoTo;   (*    des Aufpunkts.*)

PROCEDURE Box  (X,Y: CARDINAL);                       (* Rechteck linksum.*)
 BEGIN save; GoTo(X,Y0); GoTo(X,Y); GoTo(X0,Y); GoTo(X0,Y0); gauge END Box;
PROCEDURE Frame(X,Y: CARDINAL);                       (* Rahmen   linksum.*)
 BEGIN save; Pen(377C); GoTo(X,Y0); Pen('|'); GoTo(X,Y); DEC (x);
       Bc;   Pen('_');  GoTo(X0,Y); Pen('|'); GoTo(X0,Y0); gauge END Frame;

PROCEDURE save;  BEGIN X0 := x;  Y0 := y;  p := pen END save;
PROCEDURE gauge; BEGIN x0 := X0; y0 := Y0; pen := p END gauge;

PROCEDURE line;                            (* Vorlufig nur horiz. & vert.*)
                                           (*   Spter mit Bresenham ...? *)
 BEGIN IF (x > x0) THEN Rep (x-x0+1, pen);  Bc;
    ELSIF (x < x0) THEN ReP (x0-x+1, back); Fw;
    ELSIF (y > y0) THEN ReP (y-y0+1, down); Up;
    ELSIF (y < y0) THEN ReP (y0-y+1, up);   Dn;
    ELSE  wC (pen); Bc; END; END line;

PROCEDURE back; BEGIN Pt; Bc; Bc END back;
PROCEDURE down; BEGIN Pt; Dn; Bc END down;
PROCEDURE up;   BEGIN Pt; Up; Bc END up;

PROCEDURE Rep (n: CARDINAL; z: CHAR);                 (* Zeichen-Schleife,*)
 BEGIN WHILE 0<n DO DEC (n); wC (z) END; END Rep;     (*    = waag. Linie.*)
PROCEDURE ReP (n: CARDINAL; p: PROC);                 (* Prozedurschleife.*)
 BEGIN WHILE 0<n DO DEC(n); p END; END ReP;

BEGIN (*I*) pen := 0c END (*M*) Turtle;


PROCEDURE MinI (j,k: INTEGER): INTEGER;
      BEGIN IF (j<k) THEN RETURN j ELSE RETURN k END END MinI;

PROCEDURE Cosinus;
 VAR   X,Y: INTEGER;
 BEGIN FOR X := 0 TO 75 DO
           Y := 15 - entier (5.0 * cos (2.0 * pi * real (X) / 74.0));
           GoTo (X+2,Y); Pt; END (*X*); END Cosinus;

PROCEDURE Ellipse (steps, mx,my, ax,ay: INTEGER);
 VAR   X,Y,t: INTEGER; s, r,rx,ry: REAL;
 BEGIN rx := real (ax); ry := real (ay); s := real (steps);
   FOR t := 0 TO steps DO r := 2.0 * pi * real (t) / s;
       X := mx - entier (rx * cos (r));
       Y := my + entier (ry * sin (r));
       GoTo (X, Y); Pt; END (*t*); END Ellipse;

PROCEDURE Egg; VAR k: CARDINAL;
 BEGIN FOR k := 0 TO 11 DO Ellipse (15* (k+1), 39,12, k+27,k) END; END Egg;

PROCEDURE Liss;
 VAR   X1,Y1,t: INTEGER; r: REAL;
 BEGIN FOR t := 0 TO 500 DO r := 2.0 * pi * real (t) / 100.0;
           X1 := 40 - entier (20.0 * cos (3.0 * r));
           Y1 := 12 - entier (10.0 * sin (5.0 * r));
           Pen ('*'); GoTo (X1,Y1);       Pt;
           Pen (' '); GoTo (80-X1,24-Y1); Pt; END (*t*); END Liss;

PROCEDURE Nums; VAR k: INTEGER;                            (* am re. Rand.*)
 BEGIN FOR k := 0 TO 9 DO GoTo (78,3+2*k); wr (CHR(Z0+k)) END; END Nums;

PROCEDURE Scale (Y: CARDINAL); VAR k: CARDINAL;                  (* ^ ^ ^ *)
 BEGIN FOR k := 4 TO 74 BY 5 DO GoTo (k,Y); Pt END; END Scale;

PROCEDURE Hist;
 VAR   k,i: CARDINAL; val0,val: ARRAY [0..9] OF CARDINAL;
 BEGIN GoTo (0, 2); Set; Frame (75,22); Pup; Nums;
   FOR k := 4 TO 20 BY 2 DO GoTo (0, k); Rep (75, '-') END;
   Pen ('v'); Scale (1); Pen ('^'); Scale (23);
   FOR k := 0 TO   9 DO  val[k] := 0 END;
   FOR k := 0 TO 199 DO i := k MOD 10; val0[i] := val[i];
(*     IF (k MOD 20) = 0 THEN Halt END; *)         (* Einzelbild-Schalter.*)
     val[i] := 40 - entier (30.0 * cos (2.0 * pi * real (k) / 11.0));
     IF   (val[i] < val0[i]) THEN GoTo (val0[i],3+2*i); bCol (0); Clrb END;
     GoTo (val[i],3+2*i); bCol (1); Clrb; bCol (0); END (*k*) END Hist;

PROCEDURE Dia1;
 VAR    L, X,Y, maxy: INTEGER;                                   (*   ////*)
 BEGIN bCol (1); GoTo (0, 24); ClrE; bCol (0); maxy := MAXY-1;   (*  //// *)
   FOR  L := 0 TO MAXX DO                                        (* ////  *)
    FOR Y := 0 TO MinI (L, maxy) DO X := L-Y; GoTo (X, Y); Pt;   (*////   *)
     IF (X = 40) & (Y = 10)  THEN maxy := 10;
        GoTo (39,11); bCol (1); Clre; bCol (0) END; END END; END Dia1;

PROCEDURE Dia2;
 VAR   X,Y, L: INTEGER;                                          (*****   *)
 BEGIN FOR  L := 28 TO (MAXX-MAXY-1) DO                          (* ****  *)
        FOR Y :=  1 TO  MAXY DO X := L+Y; GoTo (X, Y); Pt;       (*  **** *)
            GoTo (MAXX-X, MAXY-Y); Pt; END END; END Dia2;        (*   *****)

PROCEDURE Rhomb; VAR k: CARDINAL;                                (***     *)
 BEGIN FOR k := 0 TO MAXY-1 DO GoTo (MAXY-k-1, k); Clrb;         (**     **)
           GoTo (MAXX-MAXY+k+1, MAXY-k); Clre; END; END Rhomb;   (*     ***)

PROCEDURE NewBar (a,b: CARDINAL);                                (* ]***[ *)
 BEGIN bCol (1); Home; RubL; Hole; ClrL; bCol (0);
       GoTo (a,MAXY); Clrb; IF (b > 79) THEN RETURN END;
       GoTo (b,MAXY); Clre; END NewBar;

PROCEDURE Peak; VAR i,k: CARDINAL;
 BEGIN FOR  i := 1 TO 5 DO  IF ODD (i) THEN bCol (0) ELSE bCol (1) END;
        FOR k := 0 TO MAXY DO GoXY (15+k,MAXY-k); Clrb END;
        FOR k := 0 TO MAXY DO GoXY (41+k,     k); Clre END; END; END Peak;

PROCEDURE Scroll (n: INTEGER);                     (* >0: abbi, <0: auffi.*)
 BEGIN Home;  IF (n >= 0 ) THEN ReP (n, NewL);
              ELSE ReP (-n, RubL) END; END Scroll;

PROCEDURE Blitz; BEGIN ReP (3, bliz) END Blitz;
PROCEDURE bliz;  BEGIN Clr; Dark END bliz;

PROCEDURE Rring; BEGIN bCol (1); ReP (100, rrr); bCol (0) END Rring;
PROCEDURE rrr;   BEGIN Fw; Bell; ClrE; ClrE; Bc END rrr; (* Zeit konsum.! *)

PROCEDURE Halt;  BEGIN Hole; ReP (MAXY, linc) END Halt;     (* Fr -MORE-.*)
PROCEDURE linc;  BEGIN Up; Cr (* oder Ln? *) END linc;      (* LineCount++*)

PROCEDURE CopyRite;
 CONST CRITE = 275c;
 BEGIN Goal; ReP (22, Bc); Inv1;
       ws ("  ROSHIVA, K'he "); Inv0; END CopyRite;

PROCEDURE Nr (n: INTEGER);
 BEGIN GoTo (3,2); wr (CHR(Z0+n)); Bc; BT.wC (CHR(Z0+n)) END Nr;


PROCEDURE TurtleTextDemo;
 VAR   j: CARDINAL;
 BEGIN Clr; GoTo (23, 7); ws ("Hi! ROSCHIVA K'he proudly presents: ");
            GoTo (23, 8); Pen (377c); Set; GoTo (57,8); Pup;
            GoTo (30,10); Pen ('*');  Set; Inv1; Box (48,14); Pup; Inv0;
            GoTo (31,12); ws ("  TURTLE - TEXT  "); Bell;
            GoTo ( 1, 1); Set; Frame (MAXX-1, MAXY-1);  Pup;
            Pen (371c); Cosinus; Pen (' '); Cosinus;
            Pen (370c); Ellipse (150, 39,12, 37,10);
    Nr (1); Halt; Blitz; Cur0; Peak; Scroll (MAXY DIV 2);
    Nr (2); GoTo (31,10); ws ("Das ist SPITZE !!!");
            GoTo (30,10); Cur0; ReP (100, ClrB);         (* Warteschleife.*)
            FOR j := 1 TO 27 DO NewBar (27-j, 53+j) END;        (* Peak++.*)
            FOR j := 0 TO 11 DO NewBar ( 1+j, 79-j) END;        (* Peak--.*)
    Nr (3); Inv1; Liss; Halt; Blitz;
    (* #4*) Inv0; InsertText; Rring; Cr; Cr; Cr; (*=>hlt!*); Clr;
    Nr (5); Inv0; Hist; Halt; Blitz;
            CopyRite;
    Nr (6); Inv1; Pen ('^'); Egg; Halt; Blitz; Clr; Inv0;
(*  Nr (6);           und hier is der freie Platz fr'n zell. Automaten...*)
    Nr (7); Pen ('/');           Cur0; Dia1;
            GoTo (40,17); ws ("Wir lassen keinen im Regen stehen!");
            bCol (1); fCol (0); Halt;       (* Unten schwarz; Zahl 8 wei.*)
    Nr (8); Pen (' '); Cur0; fCol (1); Dia2; Rhomb; bCol (0); Hole; ClrL;
            GoTo (28, 6); ws (" Sie sahen ein Demo von ");
            GoTo (29,10); Pen ('#');  Set; Inv1; Box (50,14); Pup; Inv0;
            GoTo (32,12); ws (" ROSCHIVA, K'he "); Bell;
            CopyRite;
            Up; Norm; Hole; Up; END TurtleTextDemo;

PROCEDURE InsertText;
 VAR   z: CHAR;
 BEGIN Inn ("TURTL*.TXT");
       IF ~ pDone^ THEN BT.wS ("  Kein Insert-Text.  ");
       ELSE BT.wS ("  Einzufgender Text-File: TURTL*.TXT.  ");
            rd (z); WHILE pDone^ DO wr (z); rd (z) END; END;
       Inn (0C) END InsertText;


MODULE Mores;
FROM   BT  IMPORT wC, Home,Hole,GoXY, Cur0, Norm;
IMPORT BT, MAXY, CR,EOT, rd,Inn,pDone;
EXPORT More;

CONST  MORE = " -MEHR- ";
       TEND = " -TEXTENDE- ";
       NOIN = " -KEIN INPUTFILE- ";

PROCEDURE More (VAR FName: ARRAY OF CHAR);         (* Vom File zum Schirm.*)
(* VAR   s: ARRAY [0..256] OF CHAR; *)
 VAR   msg: ARRAY [0.. 20] OF CHAR; i,k: CARDINAL; z,t,u: CHAR;
(* CONST CTLC = 3c; CTLS = 23c; CTLQ = 21c; *)
 BEGIN Inn (FName);
       IF ~ pDone^ THEN Hole; BT.wS (NOIN); BT.KnotC;
       ELSE Home; k := MAXY;
         REPEAT WHILE (k > 0) DO (* i := 0; *)
                  LOOP rd (z); IF ~pDone^ THEN z := EOT END;
                       IF (z = EOT) THEN k := 0; EXIT END;
                       wC (z); (* s[i] := z; INC (i); *)
(* dies wird (leider, im Falle von ^C) von rd automatisch erledigt:
                       BusyRead (u);                           (* U-Stop? *)
                       CASE u OF CTLC: z := EOT; k := 0; EXIT;
                               | CTLS: REPEAT BT.rd (u) UNTIL (u = CTLQ);
                               ELSE END (*C*);
*)                     IF (z = CR) THEN DEC (k); EXIT END; END END (*L,k*);
(*                     IF (i > HIGH (s)) THEN EXIT END;   END (*L*); *)
(*                IF (i <= HIGH (s)) THEN s[i] := 0c END; END (*k*); *)
           IF  (z = EOT) THEN msg := TEND ELSE msg := MORE END;  (* Inv1; *)
           GoXY (0,MAXY); BT.wS ("  File: "); BT.wS (FName); BT.wS (msg);
           GoXY (0,MAXY); BT.rC (t); (* Inv0; *)
           CASE t OF (* CTLC: z := EOT; *)
           | ' ': k := MAXY | CR: k := 1 | ELSE k := MAXY DIV 2 END;
         UNTIL (z = EOT);
         Cur0; END (*E*);
       Inn (0c); Norm; END More;
END (*M*) Mores;


PROCEDURE MakeT52File (VAR FName: ARRAY OF CHAR; theText: PROC);
 BEGIN                Out (FName);
       IF ~ pDone^ THEN Ln1; BT.wS (" Kein Output-File. "); BT.KnotC;
       ELSE theText;  Out (0c) END; END MakeT52File;

PROCEDURE Mark;                                     (* Zum unterstreichen.*)
 BEGIN Dn; wC (377c (*OVER*)); Bc; Up END Mark;

PROCEDURE TeDeum;
 CONST FN = "TURTLTXT.T52";
 BEGIN LOOP Norm; Clr; Ln;Ln1; BT.wS (" Turtle-Text "); Ln;Ln1;
            BT.wS (" Menue:  ");
               Mark; BT.wS ("Test,  ");  Mark; BT.wS ("File,  ");
               Mark; BT.wS ("Probe,  "); Mark; BT.wS ("Ende  ?");
         CASE CAP (BT.Query (BT.CS {'e','f','p','t'})) OF
         |'T': TurtleTextDemo;
         |'F': Ln;Ln1; BT.wS (" Es folgt: File-Erstellung. Bitte warten. ");
               Ln;Ln1; Sp;Sp; CurB; MakeT52File (FN, TurtleTextDemo); Cur0;
         |'P': More (FN);
         |'E': ClrE; EXIT;
         ELSE END END (*C,L*); END TeDeum;

BEGIN (* TAccel.Switch (2, {0..3}); *) InOut.Init (*wg.TAccel!*);
      BT.wC := InOut.Write; BT.wS := InOut.WriteString; BT.mFlag := TRUE;
      TeDeum END TurtlTxt.
